\documentclass{article}

\begin{document}
  This is what happens when a control sequence, which might ostensibly
  include a '*' in the name, is followed by a '*' and then, immediately,
  another word. Previous versions got confused and thought that the
  entire word was 'pi*I', which is impossible.

  $\pi*I$
\end{document}
